# $Id$
package Data::Tabular::Dumper::Excel;
use strict;

use Spreadsheet::WriteExcel;

###########################################################
sub open 
{
    my($package, $param)=@_;
    my($file)=@$param;
    my $book=Spreadsheet::WriteExcel->new($file);

    my $header=$book->addformat();
    $header->set_bold();
    my $default=$book->addformat();

    return bless {book=>$book, row=>0, header=>$header, 
                  empty=>1,
                  default=>$default}, $package;
}

###########################################################
sub close
{
    my($self)=@_;
    delete $self->{sheet};
    delete $self->{header};
    if( $self->{book} ) {
        $self->{book}->close();
        delete $self->{book};
    }
}


###########################################################
sub page_start
{
    my( $self, $name ) = @_;

    $self->{row} = 0;
    $self->{sheet} = $self->{book}->add_worksheet( $name );

    return;
}

###########################################################
sub page_end
{
    my( $self, $name ) = @_;

    delete $self->{sheet};
    $self->{row} = 0;
    return;
}


###########################################################
sub __write
{
    my($self, $data, $format)=@_;

    $self->{sheet} ||= $self->{book}->add_worksheet();

    my $row=$self->{row}++;
    my $col=0;
    foreach my $d (@$data) {
        $self->{sheet}->write($row, $col, $d, $format);
        $col++;
    }
}

###########################################################
sub fields
{
    my($self, $fields)=@_;
    $self->__write($fields, $self->{header});
}


###########################################################
sub write
{
    my($self, $data)=@_;
    $self->__write($data, $self->{default});
}

1;

__END__

$Log$